    PROGRAM c06fqfe

!      C06FQF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : c06fpf, c06fqf, c06gqf, c06gsf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ieof, ifail, j, m, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: trig(:), u(:), v(:), work(:), x(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'C06FQF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
LOOP:  DO
          READ (nin,*,IOSTAT=ieof) m, n
          IF (ieof<0) EXIT LOOP

          ALLOCATE (trig(2*n),u(m*n),v(m*n),work(2*m*n),x(m*n))
          DO j = 1, m
             READ (nin,*) (x(i*m+j),i=0,n-1)
          END DO
          WRITE (nout,*)
          WRITE (nout,*) 'Original data values'
          WRITE (nout,*)
          WRITE (nout,99999) ('     ',(x(i*m+j),i=0,n-1),j=1,m)
          WRITE (nout,*)
          WRITE (nout,*) 'Original data written in full complex form'

!         ifail: behaviour on error exit   
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL c06gsf(m,n,x,u,v,ifail)

          DO j = 1, m
             WRITE (nout,*)
             WRITE (nout,99999) 'Real ', (u(i*m+j),i=0,n-1)
             WRITE (nout,99999) 'Imag ', (v(i*m+j),i=0,n-1)
          END DO

          ifail = 0
          CALL c06fqf(m,n,x,'Initial',trig,work,ifail)

          WRITE (nout,*)
          WRITE (nout,*) 'Discrete Fourier transforms (real values)'
          WRITE (nout,*)
          WRITE (nout,99999) ('     ',(x(i*m+j),i=0,n-1),j=1,m)

          CALL c06fpf(m,n,x,'Subsequent',trig,work,ifail)
          CALL c06gqf(m,n,x,ifail)

          WRITE (nout,*)
          WRITE (nout,*) 'Original data as restored by inverse transform'
          WRITE (nout,*)
          WRITE (nout,99999) ('     ',(x(i*m+j),i=0,n-1),j=1,m)
          DEALLOCATE (trig,u,v,work,x)
       END DO LOOP

99999  FORMAT (1X,A,6F10.4)
    END PROGRAM c06fqfe
