    PROGRAM c06ppfe

!      C06PPF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : c06ppf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ieof, ifail, j, m, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: work(:), x(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'C06PPF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
LOOP:  DO
          READ (nin,*,IOSTAT=ieof) m, n
          IF (ieof<0) EXIT LOOP

          ALLOCATE (work((m+2)*(n+2)+11),x(m*(n+2)))
          DO j = 1, m
             READ (nin,*) (x(i*m+j),i=0,n-1)
          END DO
          WRITE (nout,*)
          WRITE (nout,*) 'Original data values'
          WRITE (nout,*)
          DO j = 1, m
             WRITE (nout,99999) '     ', (x(i*m+j),i=0,n-1)
          END DO

!         ifail: behaviour on error exit   
!                =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
          ifail = 0
          CALL c06ppf('F',m,n,x,work,ifail)

          WRITE (nout,*)
          WRITE (nout,*) &
             'Discrete Fourier transforms in complex Hermitian format'
          DO j = 1, m
             WRITE (nout,*)
             WRITE (nout,99999) 'Real ', (x(2*i*m+j),i=0,n/2)
             WRITE (nout,99999) 'Imag ', (x((2*i+1)*m+j),i=0,n/2)
          END DO
          WRITE (nout,*)
          WRITE (nout,*) 'Fourier transforms in full complex form'

          DO j = 1, m
             WRITE (nout,*)
             WRITE (nout,99999) 'Real ', (x(2*i*m+j),i=0,n/2), &
                (x(2*(n-i)*m+j),i=n/2+1,n-1)
             WRITE (nout,99999) 'Imag ', (x((2*i+1)*m+j),i=0,n/2), &
                (-x((2*(n-i)+1)*m+j),i=n/2+1,n-1)
          END DO

          CALL c06ppf('B',m,n,x,work,ifail)

          WRITE (nout,*)
          WRITE (nout,*) 'Original data as restored by inverse transform'
          WRITE (nout,*)
          DO j = 1, m
             WRITE (nout,99999) '     ', (x(i*m+j),i=0,n-1)
          END DO
          DEALLOCATE (x,work)
       END DO LOOP

99999  FORMAT (1X,A,9(:1X,F10.4))
    END PROGRAM c06ppfe
