    PROGRAM f07pdfe

!      F07PDF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dsptrf, nag_wp, x04ccf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, j, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: ap(:)
       INTEGER, ALLOCATABLE            :: ipiv(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07PDF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n

       ALLOCATE (ap(n*(n+1)/2),ipiv(n))

!      Read A from data file

       READ (nin,*) uplo
       IF (uplo=='U') THEN
          READ (nin,*) ((ap(i+j*(j-1)/2),j=i,n),i=1,n)
       ELSE IF (uplo=='L') THEN
          READ (nin,*) ((ap(i+(2*n-j)*(j-1)/2),j=1,i),i=1,n)
       END IF

!      Factorize A
!      The NAG name equivalent of dsptrf is f07pdf
       CALL dsptrf(uplo,n,ap,ipiv,info)

       WRITE (nout,*)
       FLUSH (nout)

!      Print details of factorization

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04ccf(uplo,'Nonunit',n,ap,'Details of factorization',ifail)

!      Print pivot indices

       WRITE (nout,*)
       WRITE (nout,*) 'IPIV'
       WRITE (nout,99999) ipiv(1:n)

       IF (info/=0) WRITE (nout,*) 'The factor D is singular'

99999  FORMAT ((3X,7I11))
    END PROGRAM f07pdfe
