    PROGRAM f07wefe

!      F07WEF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dpftrf, dpftrs, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, ldb, lena, n, nrhs
       CHARACTER (1)                   :: transr, uplo
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:), b(:,:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F07WEF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n, nrhs, uplo, transr

       lena = n*(n+1)/2
       ldb = n
       ALLOCATE (a(lena),b(ldb,nrhs))

!      Read A and B from data file
       READ (nin,*) a(1:lena)
       DO i = 1, n
          READ (nin,*) b(i,1:nrhs)
       END DO

!      Factorize A
       info = 0
!      The NAG name equivalent of dpftrf is f07wdf
       CALL dpftrf(transr,uplo,n,a,info)

       WRITE (nout,*)
       FLUSH (nout)
       IF (info==0) THEN

!         Compute solution
!         The NAG name equivalent of dpftrs is f07wef
          CALL dpftrs(transr,uplo,n,nrhs,a,b,ldb,info)

!         Print solution
          ifail = 0
          CALL x04caf('General',' ',n,nrhs,b,ldb,'Solution(s)',ifail)

       ELSE
          WRITE (nout,*) 'A is not positive definite'
       END IF

    END PROGRAM f07wefe
