    PROGRAM f08ajfe

!      F08AJF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dgelqf, dorglq, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, lwork, m, n
       CHARACTER (30)                  :: title
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), tau(:), work(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F08AJF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) m, n
       lda = m
       lwork = 64*m
       ALLOCATE (a(lda,n),tau(n),work(lwork))

!      Read A from data file

       READ (nin,*) (a(i,1:n),i=1,m)

!      Compute the LQ factorization of A
!      The NAG name equivalent of dgelqf is f08ahf
       CALL dgelqf(m,n,a,lda,tau,work,lwork,info)

!      Form the leading M rows of Q explicitly
!      The NAG name equivalent of dorglq is f08ajf
       CALL dorglq(m,n,m,a,lda,tau,work,lwork,info)

!      Print the leading M rows of Q only

       WRITE (nout,*)
       WRITE (title,99999) m
       FLUSH (nout)

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04caf('General',' ',m,n,a,lda,title,ifail)

99999  FORMAT ('The leading ',I2,' rows of Q')
    END PROGRAM f08ajfe
