    PROGRAM f08nefe

!      F08NEF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : dgehrd, nag_wp, x04caf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       REAL (KIND=nag_wp), PARAMETER   :: zero = 0.0E0_nag_wp
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, info, lda, lwork, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: a(:,:), tau(:), work(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F08NEF Example Program Results'
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       lda = n
       lwork = 64*n
       ALLOCATE (a(lda,n),tau(n-1),work(lwork))

!      Read A from data file

       READ (nin,*) (a(i,1:n),i=1,n)

!      Reduce A to upper Hessenberg form

!      The NAG name equivalent of dgehrd is f08nef
       CALL dgehrd(n,1,n,a,lda,tau,work,lwork,info)

!      Set the elements below the first sub-diagonal to zero

       DO i = 1, n - 2
          a(i+2:n,i) = zero
       END DO

!      Print upper Hessenberg form

       WRITE (nout,*)
       FLUSH (nout)

!      ifail: behaviour on error exit
!             =0 for hard exit, =1 for quiet-soft, =-1 for noisy-soft
       ifail = 0
       CALL x04caf('General',' ',n,n,a,lda,'Upper Hessenberg form',ifail)

    END PROGRAM f08nefe
