    PROGRAM g01fffe

!      G01FFF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g01fff, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: a, b, p, tol, x
       INTEGER                         :: ifail
!      .. Executable Statements ..
       WRITE (nout,*) 'G01FFF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Display titles
       WRITE (nout,*) '   P       A       B           X'
       WRITE (nout,*)

!      Use default tolerance
       tol = 0.0E0_nag_wp

D_LP:  DO
          READ (nin,*,IOSTAT=ifail) p, a, b
          IF (ifail/=0) THEN
             EXIT D_LP
          END IF

!         Calculate deviates (inverse CDF)
          ifail = -1
          x = g01fff(p,a,b,tol,ifail)
          IF (ifail/=0) THEN
             IF (ifail/=4 .AND. ifail/=5) THEN
                EXIT D_LP
             END IF
          END IF

!         Display results
          WRITE (nout,99999) p, a, b, x
       END DO D_LP

99999  FORMAT (1X,3F8.3,F10.3,A,I1)
    END PROGRAM g01fffe
