    PROGRAM g01gcfe

!      G01GCF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g01gcf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: df, prob, rlamda, tol, x
       INTEGER                         :: ifail, maxit
!      .. Executable Statements ..
       WRITE (nout,*) 'G01GCF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Display titles
       WRITE (nout,*) '     X       DF   RLAMDA   PROB'
       WRITE (nout,*)

!      Use default tolerance and suggested number of iterations
       tol = 0.0E0_nag_wp
       maxit = 100

D_LP:  DO
          READ (nin,*,IOSTAT=ifail) x, df, rlamda
          IF (ifail/=0) THEN
             EXIT D_LP
          END IF

!         Calculate probability
          ifail = 0
          prob = g01gcf(x,df,rlamda,tol,maxit,ifail)

!         Display results
          WRITE (nout,99999) x, df, rlamda, prob
       END DO D_LP

99999  FORMAT (1X,3F8.3,F8.4,A,I1)
    END PROGRAM g01gcfe
