    PROGRAM g02bafe

!      G02BAF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g02baf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ifail, ldr, ldssp, ldx, m, n
!      .. Local Arrays ..
       REAL (KIND=nag_wp), ALLOCATABLE :: r(:,:), ssp(:,:), std(:), x(:,:),    &
                                          xbar(:)
!      .. Executable Statements ..
       WRITE (nout,*) 'G02BAF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Read in the problem size
       READ (nin,*) n, m

       ldr = m
       ldssp = m
       ldx = n
       ALLOCATE (x(ldx,m),r(ldr,m),ssp(ldssp,m),std(m),xbar(m))

!      Read in data
       READ (nin,*) (x(i,1:m),i=1,n)

!      Display data
       WRITE (nout,99999) 'Number of variables (columns) =', m
       WRITE (nout,99999) 'Number of cases     (rows)    =', n
       WRITE (nout,*)
       WRITE (nout,*) 'Data matrix is:-'
       WRITE (nout,*)
       WRITE (nout,99998) (i,i=1,m)
       WRITE (nout,99997) (i,x(i,1:m),i=1,n)
       WRITE (nout,*)

!      Compute summary statistics
       ifail = 0
       CALL g02baf(n,m,x,ldx,xbar,std,ssp,ldssp,r,ldr,ifail)

!      Display results
       WRITE (nout,*) 'Variable   Mean    St. dev.'
       WRITE (nout,99996) (i,xbar(i),std(i),i=1,m)
       WRITE (nout,*)
       WRITE (nout,*) 'Sums of squares and cross-products of deviations'
       WRITE (nout,99998) (i,i=1,m)
       WRITE (nout,99997) (i,ssp(i,1:m),i=1,m)
       WRITE (nout,*)
       WRITE (nout,*) 'Correlation coefficients'
       WRITE (nout,99998) (i,i=1,m)
       WRITE (nout,99997) (i,r(i,1:m),i=1,m)

99999  FORMAT (1X,A,I0)
99998  FORMAT (1X,6I12)
99997  FORMAT (1X,I3,3F12.4)
99996  FORMAT (1X,I5,2F11.4)
    END PROGRAM g02bafe
