    PROGRAM g05mkfe

!      G05MKF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g05kbf, g05mkf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: n = 10, nout = 6, nr = 120
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: lambda
       INTEGER                         :: i, ifail, igen, mode
!      .. Local Arrays ..
       REAL (KIND=nag_wp)              :: r(nr)
       INTEGER                         :: iseed(4), x(n)
!      .. Executable Statements ..
       WRITE (nout,*) 'G05MKF Example Program Results'
       WRITE (nout,*)
!      Set the distribution parameter LAMBDA
       lambda = 20.0E0_nag_wp
!      Initialize the seed to a repeatable sequence
       iseed(1) = 1762543
       iseed(2) = 9324783
       iseed(3) = 42344
       iseed(4) = 742355
!      IGEN identifies the stream.
       igen = 1
       CALL g05kbf(igen,iseed)
       mode = 0
       ifail = 1
!      Generate reference vector R
       CALL g05mkf(mode,lambda,n,x,igen,iseed,r,nr,ifail)

       IF (ifail==0) THEN
          mode = 1
!         Generate integers and store in X
          ifail = 0
          CALL g05mkf(mode,lambda,n,x,igen,iseed,r,nr,ifail)

          WRITE (nout,99999) (x(i),i=1,n)
       ELSE
          WRITE (nout,99998) ifail
       END IF

99999  FORMAT (1X,I12)
99998  FORMAT (1X,' ** G05MKF returned with IFAIL = ',I5)
    END PROGRAM g05mkfe
